#include "filemonitor.h"
#include <QDir>
#include <QDebug>
namespace Fm {

FileMonitor::FileMonitor() {

}

FileMonitor::FileMonitor(const QString &strDirectory, QObject *parent)
{
    m_strListFileNames.clear();
    m_strListFileNames = QDir(strDirectory).entryList();
    m_strMonitorDirectory = strDirectory;

    m_pDirectoryWatcher = new QFileSystemWatcher(this);
    m_pDirectoryWatcher->addPath( strDirectory );

    connect( m_pDirectoryWatcher, SIGNAL(directoryChanged(const QString&)), this, SLOT(slotDirectoryChanged(const QString&)));
}

void FileMonitor::slotDirectoryChanged(const QString &strDirectory)
{
    QStringList strToAddFileNames; //新增的文件
    QStringList strToDelFileNames; //移除的文件
    QStringList strNewFileNames; //文件夹变化后的所有文件
    QFileInfoList fileInfoList = QDir(m_strMonitorDirectory).entryInfoList();

    for( int n = 0; n < fileInfoList.size(); n++ )
    {
        QFileInfo fileInfo = fileInfoList[ n ];
        strNewFileNames << fileInfo.fileName();
        if( fileInfo.fileName().compare( "." ) == 0 || fileInfo.fileName().compare( ".." ) == 0 )
            continue;

//        if( fileInfo.isDir() )
//            continue;

        QString strFileName = fileInfo.fileName();
        //如果之前文件夹不存在该文件，加入新增文件列表
        if( !m_strListFileNames.contains(strFileName))
            strToAddFileNames << strFileName;
    }
    for(QString str : m_strListFileNames)
    {
        //如果不包含之前文件夹的文件且新增文件列表不包含该文件，加入删除文件列表
        if(!strNewFileNames.contains(str) && !strNewFileNames.contains(str))
            strToDelFileNames << str;
    }

    // if(!strToDelFileNames.isEmpty())
    // {
    //     //如果删除文件列表和新增文件列表数量都为1，重命名操作
    //     if(strToDelFileNames.size() == 1 && strToAddFileNames.size() == 1)
    //     {
    //         qDebug() << "rename " << strToDelFileNames;
    //         QString strFilePath = m_strMonitorDirectory + "/" + strToDelFileNames[0];
    //         Q_EMIT sigDirChange(Delete, strFilePath);
    //         strFilePath = m_strMonitorDirectory + "/" + strToAddFileNames[0];
    //         Q_EMIT sigDirChange(New, strFilePath);
    //         goto End;
    //     }
    //     else
    //     {
    //         qDebug() << "del " << strToDelFileNames;
    //         for(QString tmp : strToDelFileNames)
    //         {
    //             QString strFilePath = m_strMonitorDirectory + "/" + tmp;
    //             Q_EMIT sigDirChange(Delete, strFilePath);
    //         }
    //         goto End;
    //     }
    // }
    for(QString tmp : strToDelFileNames)
    {
        QString strFilePath = m_strMonitorDirectory + "/" + tmp;
        Q_EMIT sigDirChange(Delete, strFilePath);
    }
    for( int n = 0; n < strToAddFileNames.size(); n++ )
    {
        QString strFilePath = m_strMonitorDirectory + "/" + strToAddFileNames[ n ];
        Q_EMIT sigDirChange(New, strFilePath );
    }
End:
    m_strListFileNames.clear();
    m_strListFileNames = GetFileNames(fileInfoList);
    return;
}

void FileMonitor::slotFileChanged(const QString &file)
{
    QFileInfo info(file);
    if(m_strListFileNames.contains(info.fileName()))
    {
        Q_EMIT sigDirChange(Change, file);
    }
    else {

    }
    m_strListFileNames.clear();
    QFileInfoList fileInfoList = QDir(m_strMonitorDirectory).entryInfoList();
    m_strListFileNames = GetFileNames(fileInfoList);
}

QStringList FileMonitor::GetFileNames(const QFileInfoList &fileInfoList)
{
    QStringList strLstNames;
    int nFileNum = fileInfoList.size();
    for( int n = 0; n < nFileNum; n++ )
    {
        QFileInfo fileInfo = fileInfoList[ n ];
        strLstNames << fileInfo.fileName();
    }
    return strLstNames;
}

} // namespace Fm
